#!/usr/bin/perl

use Fcntl;

my $logFolder = "./log";

my ($sec,$min,$hour,$mday,$mon,$year) = localtime(time);
$year += 1900;
$mon++;
$mon = sprintf("%02d", $mon);
$mday= sprintf("%02d", $mday);
my $date = join(undef, $year, $mon, $mday);

if(!(-d $logFolder)){ mkdir $logFolder; }
my $fileName = $logFolder . '/' . $date . ".txt";
if(!(-f $fileName)){ $flg = 1; }

if($ENV{QUERY_STRING}){
	my @data = split(/\,/,$ENV{QUERY_STRING});
	sysopen(TXT,$fileName, O_WRONLY | O_APPEND | O_CREAT);
	print TXT "$data[0],$ENV{HTTP_REFERER},$data[1],$date,$ENV{'REMOTE_ADDR'},$data[2],$data[3]\n";
	close(TXT);
}

if($flg){ chmod 0666, $fileName; }

print<<EOF
Content-type: image/gif
Pragma: no-cache
Cache-Control: no-cache
Expires: Thu, 01 Dec 1994 16:00:00 GMT


EOF

