#!/usr/bin/perl

use lib 'lib';
use MjDisp;
use Fcntl;

&main2;

sub main{

  my $doc  = MjDisp::createDocument('Ỏ{');
  my $main = $doc->createTemplate('main');
  $doc->append($main);

  $doc->write;
}


sub main2{
  my %form = &formRead;
  
  if(!$form{'pwd'} || !&login($form{'pwd'})){
	  my $doc  = MjDisp::createDocument('MjClickANZX OC');
	  $doc->style('./master.css');
      my $login = $doc->createTemplate('login');
      $doc->append($login);
      $doc->write;
      
  }else{
  
  my $doc  = MjDisp::createDocument('Ỏ{');
  $doc->style('./master.css');
  $doc->script('./decode.js');
  $main = $doc->createTemplate('main');
  $main->append('pwd', $form{'pwd'});

  my @files = &getDayLog('./log/', 'txt');
  my @fileSet = @files;
  if(@fileSet && !$form{'start_day'}){ $form{'start_day'} = substr($fileSet[$#fileSet], 0, -4); }
  if(@fileSet && !$form{'end_day'}){ $form{'end_day'} = substr($fileSet[$#fileSet], 0, -4); }
  @files = &fileFilter($form{'start_day'}, $form{'end_day'}, @files);
  my @log = &openLogData(@files);
  my %map = &createMapping(@log);
  
  if(!$form{'reffrer'}){
    # O\
    my $table = $doc->createTemplate('table');
    $main->append('Table', $table);
    my @logs = distinct(@log);
    foreach(@logs){
      if($form{'page_filter'} && $form{'page_filter'} ne '-' && $form{'page_filter'} ne $_->[1]){ next; }
      my $dataRow = $doc->createTemplate('log');
      $dataRow->append('RefUrl',  $_->[2]);
      $dataRow->append('BaseUrl', $_->[1]);
      $dataRow->append('ForUrl',  $_->[0]);
      $dataRow->append('BaseTitle', $map{$_->[1]});
      $dataRow->append('ForTitle',  $map{$_->[0]});
      if(&getDomain($_->[2])){$dataRow->append('RefTitle',  "[ " . &getDomain($_->[2]) . " ]" )};
      $dataRow->append('Count',   $_->[3]);
      $table->append('LogData', $dataRow);
    }
  }
  else{
    # O\(NȂ)
    my $table = $doc->createTemplate('table2');
    $main->append('Table', $table);
    my @logs = distinctForOnly(@log);
    foreach(@logs){
      if($form{'page_filter'} && $form{'page_filter'} ne '-' && $form{'page_filter'} ne $_->[1]){ next; }
      my $dataRow = $doc->createTemplate('log2');
      $dataRow->append('BaseUrl', $_->[1]);
      $dataRow->append('BaseTitle', $map{$_->[1]});
      $dataRow->append('ForUrl',  $_->[0]);
      $dataRow->append('ForTitle',  $map{$_->[0]});
      $dataRow->append('Count',   $_->[2]);
      $table->append('LogData', $dataRow);
    }
    $main->append('ref_check', 'selected="selected"');
  }
  $doc->append($main);
  


  # ttB^쐬
  foreach(@fileSet){
    my @dayStr = split(/\./);
    my $dayRow = $doc->createElement('option');
    $dayRow->append(&parseDayFormat($dayStr[0]));
    $dayRow->setAttribute('value', $dayStr[0]);
    if($form{'start_day'} eq $dayStr[0]){ $dayRow->setAttribute('selected', 'selected'); }
    $main->append('StartDay', $dayRow);
  }
  foreach(@fileSet){
    my @dayStr = split(/\./);
    my $dayRow = $doc->createElement('option');
    $dayRow->append(&parseDayFormat($dayStr[0]));
    $dayRow->setAttribute('value', $dayStr[0]);
    if($form{'end_day'} eq $dayStr[0]){ $dayRow->setAttribute('selected', 'selected'); }
    $main->append('EndDay', $dayRow);
  }
  
  # y[WtB^쐬
  my @pages = pageList(@log);
  unshift @pages, '-';
  foreach(@pages){
    if(!$_){ next; }
    my $pageRow = $doc->createElement('option');
    $pageRow->append($map{$_});
    $pageRow->setAttribute('value', $_);
    $pageRow->setAttribute('title', $_);
    if($_ eq $form{'page_filter'}){ $pageRow->setAttribute('selected', 'selected'); }
    $main->append('PageFilter', $pageRow);
  }
  
  
  $doc->write;
}
}

# dJEg
sub distinct{
  my(@log) = @_;
  my %data;
  my @logs;

  # JEg
  foreach(@log){
    $data{join(',', $_->[0], $_->[1], $_->[2])}++;
  }
  # zɍđ
  while(my($key, $val) = each %data){
    my @col = split(/\,/, $key);
    $col[3] = $val;
    push @logs, \@col;
  }
  # \[g
  @logs = sort { $b->[3] <=> $a->[3] } @logs;
  return @logs;
}

# dJEg
sub distinctForOnly{
  my(@log) = @_;
  my %data;
  my @logs;

  # JEg
  foreach(@log){
    $data{join(',',$_->[0], $_->[1])}++;
  }
  # zɍđ
  while(my($key, $val) = each %data){
    my @col = split(/\,/, $key);
    $col[2] = $val;
    push @logs, \@col;
  }
  # \[g
  @logs = sort { $b->[2] <=> $a->[2] } @logs;
  return @logs;
}

# Of[^J
sub openLogData{
  my(@files) = @_;
  my @log;
  foreach(@files){
    if($_ =~ m/^\d{8}\.txt$/){
    sysopen(TXT, './log/' . $_ ,O_RDONLY);
    push @log, <TXT>;
    close(TXT);
    }
  }
  foreach(@log){
    chomp;
    my @col = split(/\,/);
    $_ = \@col;
  }
  return @log;
}

# ݂̃y[W̃XgԂ
sub pageList{
  my(@log) = @_;
  my @pages;
  my %count;
  
  foreach(@log){ $count{$_->[1]}++; }
  @log = undef;
  while(my($key,$val) = each %count){
    my @row = ($key, $val);
    push @log, \@row;
  }
  @log = sort { $b->[1] <=> $a->[1] } @log;
  @pages = map { $_->[0] } @log;
  return @pages;
}



# tH[ǂݍ
sub formRead{
	my $this = shift;
	read(STDIN,my $query, $ENV{'CONTENT_LENGTH'});
	my @query = split(/&/,$query);
	my %form;
	foreach(@query){
		my($name,$value) = split(/=/);
		$value =~ tr/+/ /;
		$value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
		$value =~ s/<(?:[^>'"]*|(['"]).*?\1)*>//gs;    #"
#		&jcode::convert(*value, "euc");
		$form{$name} = $value;
	}
	return %form;
}



# tf[^ꗗ擾

sub getDayLog{
  my($dir, $ext) = @_;
  if(!(-d $dir)){ mkdir $dir; }
  opendir(DIR, $dir);
  my @files = sort grep { /\.$ext$/ && -f "$dir/$_"} readdir(DIR);
  closedir(DIR);
  return @files;
}

# tf[^tH[}bg
sub parseDayFormat{
  my($str) = @_;
  $str =~ m/^(\d{4})(\d{2})(\d{2})$/;
  return join('/', $1, $2, $3);
}


# \t@Ci
sub fileFilter{
  my($start, $end, @files) = @_;
  my @newFiles;
  if($start > $end){ my $tmp = $start;$start = $end;$end = $tmp; }
  foreach(@files){
    if($_ >= $start && $_ <= $end){ push @newFiles, $_ }
  }
  return @newFiles;
}

# ^Cg̃}bsO쐬
sub createMapping{
  my(@log) = @_;
  my %map;
  foreach(@log){
    if($_->[0] && $_->[5]){ $map{$_->[0]} = &base64decode($_->[5]); }
    if($_->[1] && $_->[6]){ $map{$_->[1]} = &base64decode($_->[6]); }
  }
  return %map;
}

# MIME/BASE64`fR[h
sub base64decode{
  my($str) = @_;
#  my $len = pack("C", 32 + 0.75 * length($str));
#	$str = unpack("U", $len . $str);
  $str =~ s/%([0-9a-fA-F]{2})/pack("C", hex($1))/eg;
#  $str =~ s/%u([0-9a-fA-F]{4})/pack("a", hex($1))/eg;
  return $str;
}

# hC؂o
sub getDomain{
  my($str) = @_;
  $str =~ m/^https?\:\/\/([a-zA-Z0-9\.\-_]+)/;
  return $1;
}

# F
sub login{
  my($passwd) = @_;
  sysopen(TXT,'./passwd.cgi', O_RDONLY);
  my @data = <TXT>;
  close(TXT);
  if($passwd eq $data[0]){ return 1; }
  else{ return 0; }
}


